package org.jeecg.modules.statistics.controller;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.device.entity.BuDevice;
import org.jeecg.modules.device.service.IBuDeviceOnlineService;
import org.jeecg.modules.device.service.IBuDeviceService;
import org.jeecg.modules.statistics.entity.BuHydraulicPumpFaultStatistics;
import org.jeecg.modules.statistics.model.LineStatistics;
import org.jeecg.modules.statistics.service.IBuHydraulicPumpFaultStatisticsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @Description: 液压泵故障分析表
 * @Author: jeecg-boot
 * @Date:   2021-01-25
 * @Version: V1.0
 */
@Api(tags="液压泵故障分析表")
@RestController
@RequestMapping("/statistics/buHydraulicPumpFaultStatistics")
@Slf4j
public class BuHydraulicPumpFaultStatisticsController extends JeecgController<BuHydraulicPumpFaultStatistics, IBuHydraulicPumpFaultStatisticsService> {
	@Autowired
	private IBuHydraulicPumpFaultStatisticsService buHydraulicPumpFaultStatisticsService;
	@Autowired
	private IBuDeviceOnlineService buDeviceOnlineService;
	@Autowired
	private IBuDeviceService buDeviceService;
	
	/**
	 * 分页列表查询
	 *
	 * @param buHydraulicPumpFaultStatistics
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "液压泵故障分析表-分页列表查询")
	@ApiOperation(value="液压泵故障分析表-分页列表查询", notes="液压泵故障分析表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(BuHydraulicPumpFaultStatistics buHydraulicPumpFaultStatistics,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuHydraulicPumpFaultStatistics> queryWrapper = QueryGenerator.initQueryWrapper(buHydraulicPumpFaultStatistics, req.getParameterMap());
		Page<BuHydraulicPumpFaultStatistics> page = new Page<BuHydraulicPumpFaultStatistics>(pageNo, pageSize);
		IPage<BuHydraulicPumpFaultStatistics> pageList = buHydraulicPumpFaultStatisticsService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param buHydraulicPumpFaultStatistics
	 * @return
	 */
	@AutoLog(value = "液压泵故障分析表-添加")
	@ApiOperation(value="液压泵故障分析表-添加", notes="液压泵故障分析表-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody BuHydraulicPumpFaultStatistics buHydraulicPumpFaultStatistics) {
		buHydraulicPumpFaultStatisticsService.save(buHydraulicPumpFaultStatistics);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param buHydraulicPumpFaultStatistics
	 * @return
	 */
	@AutoLog(value = "液压泵故障分析表-编辑")
	@ApiOperation(value="液压泵故障分析表-编辑", notes="液压泵故障分析表-编辑")
	@PutMapping(value = "/edit")
	public Result<?> edit(@RequestBody BuHydraulicPumpFaultStatistics buHydraulicPumpFaultStatistics) {
		buHydraulicPumpFaultStatisticsService.updateById(buHydraulicPumpFaultStatistics);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "液压泵故障分析表-通过id删除")
	@ApiOperation(value="液压泵故障分析表-通过id删除", notes="液压泵故障分析表-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		buHydraulicPumpFaultStatisticsService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "液压泵故障分析表-批量删除")
	@ApiOperation(value="液压泵故障分析表-批量删除", notes="液压泵故障分析表-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buHydraulicPumpFaultStatisticsService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	//所有设备异常信息统计
	@GetMapping(value = "/getTypeUnusual")
	public Result<?> getTypeUnusual() {
		List<LineStatistics> list = buDeviceOnlineService.getTypeUnusual();
		return Result.OK(list);
	}
	//所有设备异常信息统计
	@GetMapping(value = "/getTypeUnusualByType")
	public Result<?> getTypeUnusualByType(@RequestParam(name="typeId",required=true) String typeId) {
		List<LineStatistics> list = buDeviceOnlineService.getTypeUnusualByType(typeId);
		return Result.OK(list);
	}
	//所有设备异常信息统计
	@GetMapping(value = "/getUnusualData")
	public Result<?> getUnusualData() {
		List<LineStatistics> list = buDeviceOnlineService.getUnusual();
		return Result.OK(list);
	}

	//单个设备异常信息统计
	@GetMapping(value = "/getOneDevice")
	public Result<?> getOneDevice(String name) {
		List<JSONObject> list = new ArrayList<>();
		BuDevice buDevice = buDeviceService.getById(name);
		for (int i=1; i<13; i++){
			JSONObject obj = new JSONObject();
			int count = buDeviceOnlineService.getOneUnusual(buDevice.getDeviceName(),i);
			obj.put("x",i+"月");
			obj.put("y",count);
			list.add(obj);
		}
		return Result.OK(list);
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "液压泵故障分析表-通过id查询")
	@ApiOperation(value="液压泵故障分析表-通过id查询", notes="液压泵故障分析表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		BuHydraulicPumpFaultStatistics buHydraulicPumpFaultStatistics = buHydraulicPumpFaultStatisticsService.getById(id);
		if(buHydraulicPumpFaultStatistics==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buHydraulicPumpFaultStatistics);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buHydraulicPumpFaultStatistics
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuHydraulicPumpFaultStatistics buHydraulicPumpFaultStatistics) {
        return super.exportXls(request, buHydraulicPumpFaultStatistics, BuHydraulicPumpFaultStatistics.class, "液压泵故障分析表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuHydraulicPumpFaultStatistics.class);
    }

}
